import * as antlr from "antlr4ng";
import { RedisParserVisitor } from "./RedisParserVisitor.js";
export declare class RedisParser extends antlr.Parser {
    static readonly SPACE = 1;
    static readonly NEWLINE = 2;
    static readonly SET = 3;
    static readonly GET = 4;
    static readonly INCR = 5;
    static readonly DECR = 6;
    static readonly NX = 7;
    static readonly XX = 8;
    static readonly EX = 9;
    static readonly PX = 10;
    static readonly EXAT = 11;
    static readonly PXAT = 12;
    static readonly KEEPTTL = 13;
    static readonly SINGLE_QUOTE = 14;
    static readonly DOUBLE_QUOTE = 15;
    static readonly DECIMAL_LITERAL = 16;
    static readonly IDENTIFIER = 17;
    static readonly RULE_root = 0;
    static readonly RULE_commands = 1;
    static readonly RULE_command = 2;
    static readonly RULE_setCommand = 3;
    static readonly RULE_keyExistenceClause = 4;
    static readonly RULE_expirationClause = 5;
    static readonly RULE_getCommand = 6;
    static readonly RULE_incrementCommand = 7;
    static readonly RULE_decrementCommand = 8;
    static readonly RULE_identifier = 9;
    static readonly RULE_keyName = 10;
    static readonly literalNames: (string | null)[];
    static readonly symbolicNames: (string | null)[];
    static readonly ruleNames: string[];
    get grammarFileName(): string;
    get literalNames(): (string | null)[];
    get symbolicNames(): (string | null)[];
    get ruleNames(): string[];
    get serializedATN(): number[];
    protected createFailedPredicateException(predicate?: string, message?: string): antlr.FailedPredicateException;
    constructor(input: antlr.TokenStream);
    root(): RootContext;
    commands(): CommandsContext;
    command(): CommandContext;
    setCommand(): SetCommandContext;
    keyExistenceClause(): KeyExistenceClauseContext;
    expirationClause(): ExpirationClauseContext;
    getCommand(): GetCommandContext;
    incrementCommand(): IncrementCommandContext;
    decrementCommand(): DecrementCommandContext;
    identifier(): IdentifierContext;
    keyName(): KeyNameContext;
    static readonly _serializedATN: number[];
    private static __ATN;
    static get _ATN(): antlr.ATN;
    private static readonly vocabulary;
    get vocabulary(): antlr.Vocabulary;
    private static readonly decisionsToDFA;
}
export declare class RootContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    EOF(): antlr.TerminalNode;
    commands(): CommandsContext | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class CommandsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    command(): CommandContext;
    NEWLINE(): antlr.TerminalNode[];
    NEWLINE(i: number): antlr.TerminalNode | null;
    commands(): CommandsContext | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class CommandContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    setCommand(): SetCommandContext | null;
    getCommand(): GetCommandContext | null;
    incrementCommand(): IncrementCommandContext | null;
    decrementCommand(): DecrementCommandContext | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class SetCommandContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    SET(): antlr.TerminalNode;
    keyName(): KeyNameContext;
    identifier(): IdentifierContext;
    keyExistenceClause(): KeyExistenceClauseContext | null;
    GET(): antlr.TerminalNode | null;
    expirationClause(): ExpirationClauseContext | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class KeyExistenceClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    NX(): antlr.TerminalNode | null;
    XX(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class ExpirationClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    EX(): antlr.TerminalNode | null;
    DECIMAL_LITERAL(): antlr.TerminalNode | null;
    PX(): antlr.TerminalNode | null;
    EXAT(): antlr.TerminalNode | null;
    PXAT(): antlr.TerminalNode | null;
    KEEPTTL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class GetCommandContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    GET(): antlr.TerminalNode;
    keyName(): KeyNameContext;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class IncrementCommandContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    INCR(): antlr.TerminalNode;
    keyName(): KeyNameContext;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class DecrementCommandContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    DECR(): antlr.TerminalNode;
    keyName(): KeyNameContext;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class IdentifierContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    IDENTIFIER(): antlr.TerminalNode | null;
    DECIMAL_LITERAL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
export declare class KeyNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext;
    get ruleIndex(): number;
    accept<Result>(visitor: RedisParserVisitor<Result>): Result | null;
}
